diff --git a/imap/imap.c b/imap/imap.c
index 7a6df13404..51f7f94302 100644
--- a/imap/imap.c
+++ b/imap/imap.c
@@ -1216,11 +1216,13 @@ int imap_exec_msgset(struct ImapData *idata, const char *pre, const char *post,
 {
   struct Header **hdrs = NULL;
   short oldsort;
-  struct Buffer cmd = {0};
+  struct Buffer cmd;
   int pos;
   int rc;
   int count = 0;
 
+  mutt_buffer_init(&cmd);
+
   /* We make a copy of the headers just in case resorting doesn't give
    exactly the original order (duplicate messages?), because other parts of
    the ctx are tied to the header order. This may be overkill. */
@@ -1933,7 +1935,8 @@ int imap_fast_trash(struct Context *ctx, char *dest)
     mutt_str_strfcpy(mbox, "INBOX", sizeof(mbox));
   imap_munge_mbox_name(idata, mmbox, sizeof(mmbox), mbox);
 
-  struct Buffer sync_cmd = {0};
+  struct Buffer sync_cmd;
+  mutt_buffer_init(&sync_cmd);
   for (int i = 0; i < ctx->msgcount; i++)
   {
     if (ctx->hdrs[i]->active && ctx->hdrs[i]->changed &&
@@ -2713,7 +2716,8 @@ static int imap_commit_message_tags(struct Context *ctx, struct Header *h, char
   /* Remove old custom flags */
   if (HEADER_DATA(h)->flags_remote)
   {
-    struct Buffer cmd = {0};
+    struct Buffer cmd;
+    mutt_buffer_init(&cmd);
     mutt_buffer_addstr(&cmd, "UID STORE ");
     mutt_buffer_addstr(&cmd, uid);
     mutt_buffer_addstr(&cmd, " -FLAGS.SILENT (");
@@ -2734,7 +2738,8 @@ static int imap_commit_message_tags(struct Context *ctx, struct Header *h, char
   /* Add new custom flags */
   if (tags)
   {
-    struct Buffer cmd = {0};
+    struct Buffer cmd;
+    mutt_buffer_init(&cmd);
     mutt_buffer_addstr(&cmd, "UID STORE ");
     mutt_buffer_addstr(&cmd, uid);
     mutt_buffer_addstr(&cmd, " +FLAGS.SILENT (");
diff --git a/imap/message.c b/imap/message.c
index 2554ed66bf..fb35343e34 100644
--- a/imap/message.c
+++ b/imap/message.c
@@ -805,7 +805,8 @@ int imap_read_headers(struct ImapData *idata, unsigned int msn_begin, unsigned i
   while (msn_begin <= msn_end && fetch_msn_end < msn_end)
   {
     char *cmd = NULL;
-    struct Buffer b = {0};
+    struct Buffer b;
+    mutt_buffer_init(&b);
     if (evalhc)
     {
       /* In case there are holes in the header cache. */
diff --git a/init.c b/init.c
index 2d31c7d0a4..100499c1ba 100644
--- a/init.c
+++ b/init.c
@@ -3296,11 +3296,12 @@ static int parse_source(struct Buffer *tmp, struct Buffer *token,
 int mutt_parse_rc_line(/* const */ char *line, struct Buffer *token, struct Buffer *err)
 {
   int i, r = 0;
-  struct Buffer expn = {0};
+  struct Buffer expn;
 
   if (!line || !*line)
     return 0;
 
+  mutt_buffer_init(&expn);
   mutt_buffer_addstr(&expn, line);
   mutt_buffer_rewind(&expn);
 
diff --git a/mbyte.c b/mbyte.c
index cd9b040f5f..cdd73b0df2 100644
--- a/mbyte.c
+++ b/mbyte.c
@@ -77,13 +77,15 @@ bool is_display_corrupting_utf8(wchar_t wc)
 
 int mutt_filter_unprintable(char **s)
 {
-  struct Buffer b = {0};
+  struct Buffer b;
   wchar_t wc;
   size_t k, k2;
   char scratch[MB_LEN_MAX + 1];
   char *p = *s;
   mbstate_t mbstate1, mbstate2;
 
+  mutt_buffer_init(&b);
+
   memset(&mbstate1, 0, sizeof(mbstate1));
   memset(&mbstate2, 0, sizeof(mbstate2));
   for (; (k = mbrtowc(&wc, p, MB_LEN_MAX, &mbstate1)); p += k)
diff --git a/muttlib.c b/muttlib.c
index 10934cd52b..e913f4be4a 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -928,14 +928,18 @@ void mutt_expando_format(char *buf, size_t buflen, size_t col, int cols, const c
     /* n-off is the number of backslashes. */
     if (off > 0 && ((n - off) % 2) == 0)
     {
-      struct Buffer word = {0};
-      struct Buffer command = {0};
-      struct Buffer srcbuf = {0};
+      struct Buffer word;
+      struct Buffer command;
+      struct Buffer srcbuf;
       char srccopy[LONG_STRING];
 #ifdef DEBUG
       int i = 0;
 #endif
 
+      mutt_buffer_init(&word);
+      mutt_buffer_init(&command);
+      mutt_buffer_init(&srcbuf);
+
       mutt_debug(3, "fmtpipe = %s\n", src);
 
       strncpy(srccopy, src, n);
